diff --git a/gcc/tree-core.h b/gcc/tree-core.h
index ea9f281f1cc..86a07c282af 100644
--- a/gcc/tree-core.h
+++ b/gcc/tree-core.h
@@ -1589,17 +1589,17 @@ struct GTY(()) tree_ssa_name {
 
   /* Value range information.  */
   union ssa_name_info_type {
+    /* Ranges for integers.  */
+    struct GTY ((tag ("0"))) irange_storage_slot *irange_info;
+    /* Ranges for floating point numbers.  */
+    struct GTY ((tag ("1"))) frange_storage_slot *frange_info;
     /* Pointer attributes used for alias analysis.  */
-    struct GTY ((tag ("0"))) ptr_info_def *ptr_info;
+    struct GTY ((tag ("2"))) ptr_info_def *ptr_info;
     /* This holds any range info supported by ranger (except ptr_info
        above) and is managed by vrange_storage.  */
     void * GTY ((skip)) range_info;
-    /* GTY tag when the range in the range_info slot above satisfies
-       irange::supports_type_p.  */
-    struct GTY ((tag ("1"))) irange_storage_slot *irange_info;
   } GTY ((desc ("%1.typed.type ?" \
-		"!POINTER_TYPE_P (TREE_TYPE ((tree)&%1)) : 2"))) info;
-
+		"(POINTER_TYPE_P (TREE_TYPE ((tree)&%1)) ? 2 : SCALAR_FLOAT_TYPE_P (TREE_TYPE ((tree)&%1))) : 3"))) info;
   /* Immediate uses list for this SSA_NAME.  */
   struct ssa_use_operand_t imm_uses;
 };
diff --git a/gcc/value-range-storage.cc b/gcc/value-range-storage.cc
index 8b5ab544ce3..ea3b83ca641 100644
--- a/gcc/value-range-storage.cc
+++ b/gcc/value-range-storage.cc
@@ -40,7 +40,8 @@ vrange_storage::alloc_slot (const vrange &r)
 
   if (is_a <irange> (r))
     return irange_storage_slot::alloc_slot (*m_alloc, as_a <irange> (r));
-
+  if (is_a <frange> (r))
+    return frange_storage_slot::alloc_slot (*m_alloc, as_a <frange> (r));
   return NULL;
 }
 
@@ -55,6 +56,12 @@ vrange_storage::set_vrange (void *slot, const vrange &r)
       gcc_checking_assert (s->fits_p (as_a <irange> (r)));
       s->set_irange (as_a <irange> (r));
     }
+  else if (is_a <frange> (r))
+    {
+      frange_storage_slot *s = static_cast <frange_storage_slot *> (slot);
+      gcc_checking_assert (s->fits_p (as_a <frange> (r)));
+      s->set_frange (as_a <frange> (r));
+    }
   else
     gcc_unreachable ();
 }
@@ -70,6 +77,12 @@ vrange_storage::get_vrange (const void *slot, vrange &r, tree type)
 	= static_cast <const irange_storage_slot *> (slot);
       s->get_irange (as_a <irange> (r), type);
     }
+  else if (is_a <frange> (r))
+    {
+      const frange_storage_slot *s
+	= static_cast <const frange_storage_slot *> (slot);
+      s->get_frange (as_a <frange> (r), type);
+    }
   else
     gcc_unreachable ();
 }
@@ -85,6 +98,12 @@ vrange_storage::fits_p (const void *slot, const vrange &r)
 	= static_cast <const irange_storage_slot *> (slot);
       return s->fits_p (as_a <irange> (r));
     }
+  if (is_a <frange> (r))
+    {
+      const frange_storage_slot *s
+	= static_cast <const frange_storage_slot *> (slot);
+      return s->fits_p (as_a <frange> (r));
+    }
   gcc_unreachable ();
   return false;
 }
@@ -215,3 +234,43 @@ debug (const irange_storage_slot &storage)
   storage.dump ();
   fprintf (stderr, "\n");
 }
+
+// Implementation of frange_storage_slot.
+
+frange_storage_slot *
+frange_storage_slot::alloc_slot (vrange_allocator &allocator, const frange &r)
+{
+  size_t size = sizeof (frange_storage_slot);
+  frange_storage_slot *p
+    = static_cast <frange_storage_slot *> (allocator.alloc (size));
+  new (p) frange_storage_slot (r);
+  return p;
+}
+
+void
+frange_storage_slot::set_frange (const frange &r)
+{
+  gcc_checking_assert (fits_p (r));
+  gcc_checking_assert (!r.undefined_p ());
+
+  m_props = r.m_props;
+}
+
+void
+frange_storage_slot::get_frange (frange &r, tree type) const
+{
+  gcc_checking_assert (r.supports_type_p (type));
+
+  r.set_varying (type);
+  r.m_props = m_props;
+  r.normalize_kind ();
+
+  if (flag_checking)
+    r.verify_range ();
+}
+
+bool
+frange_storage_slot::fits_p (const frange &) const
+{
+  return true;
+}
diff --git a/gcc/value-range-storage.h b/gcc/value-range-storage.h
index 5a3336b673b..3fac5ea2f86 100644
--- a/gcc/value-range-storage.h
+++ b/gcc/value-range-storage.h
@@ -100,6 +100,25 @@ private:
   trailing_wide_ints<MAX_INTS> m_ints;
 };
 
+// A chunk of memory to store an frange to long term memory.
+
+class GTY (()) frange_storage_slot
+{
+ public:
+  static frange_storage_slot *alloc_slot (vrange_allocator &, const frange &r);
+  void set_frange (const frange &r);
+  void get_frange (frange &r, tree type) const;
+  bool fits_p (const frange &) const;
+ private:
+  frange_storage_slot (const frange &r) { set_frange (r); }
+  DISABLE_COPY_AND_ASSIGN (frange_storage_slot);
+
+  // We can get away with just storing the properties because the type
+  // can be gotten from the SSA, and UNDEFINED is unsupported, so it
+  // can only be a range.
+  frange_props m_props;
+};
+
 class obstack_vrange_allocator : public vrange_allocator
 {
 public: